Unit GSN3R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure GSN3R(var ISEED :Integer; N :Integer; var R :Array of Real); 

implementation

procedure GSN3R(var ISEED :Integer; N :Integer; var R :Array of Real);
var
NN,I,M :Integer;
U,V,SLN,SUM :Real;
Z :Extended;
const
D2P31M :Extended = 2147483647.0e0;
D2PN31 :Extended = 4.656612873077393e-10;
D2P32M :Real = 1.6807E04;
label
_1,_2;
begin
NN := N;
M := N-(N div 2)*2;
if ( M <> 0 ) 
 then NN := NN-1;
Z := (ISEED);
I := 1;
while ( I<=NN ) do
 begin
_1:
  Z := Emod(D2P32M*Z,D2P31M);
  U := Z*D2PN31;
  Z := Emod(D2P32M*Z,D2P31M);
  V := Z*D2PN31;
  U := U+U-1.0;
  V := V+V-1.0;
  SUM := U*U+V*V;
  if ( SUM >= 1.0 ) 
   then goto _1;
  SLN := Ln(SUM);
  SLN := Sqrt((-SLN-SLN)/SUM);
  R[I-1] := U*SLN;
  R[I+0] := V*SLN;
_2:
  inc(I,2);
 end;
ISEED := Trunc( Z );
end;

end.
